/*****************************************************************************
 * bf609_w25q32bv_dpia.c
 *****************************************************************************/

#include <sys/platform.h>

#include "common/flash.h"
#include "common/spi.h"

const char *pEzKitTitle = "UCB-BF609";

extern const struct spi_ctlr adi_spi_bf6xx_ctlr;
extern struct flash_info n25q064a11e_info;

void dpia_init(void)
{
//	*pIMEM_CONTROL = 0;
//	*pDMEM_CONTROL = 0;

	/* Reset SCI */
    *pREG_SEC0_CCTL0 |= ENUM_SEC_CCTL_RESET;
	/* Clear NMI */
	*pREG_SEC0_CSTAT0 |= ENUM_SEC_CSTAT_NMI;
	/* Reset SEC */
    *pREG_SEC0_GCTL = ENUM_SEC_GCTL_RESET;

	spi_ctlr = &adi_spi_bf6xx_ctlr;
	flash_info = &n25q064a11e_info;

	/* disable DMA7 which might be running and will trigger
	   Rx interrupt handler as soon as we install it.  */
	*pREG_DMA7_CFG = 0;

	*pREG_PORTA_DIR = 0;
	*pREG_PORTB_DIR = 0;
	*pREG_PORTC_DIR = 0;
	*pREG_PORTD_DIR = 0;
	*pREG_PORTE_DIR = 0;
	*pREG_PORTF_DIR = 0;
	*pREG_PORTG_DIR = 0;

	*pREG_PORTA_FER = 0;
	*pREG_PORTB_FER = 0;
	*pREG_PORTC_FER = 0;
	*pREG_PORTD_FER = BITM_PORT_DATA_PX2 | BITM_PORT_DATA_PX3 | BITM_PORT_DATA_PX4;
	*pREG_PORTE_FER = 0;
	*pREG_PORTF_FER = 0;

	*pREG_PORTD_MUX = 0U;

	/* We use GPIO PD11 as SPI flash /CS.
	   Clear FER bit since the boot code will set it on boot mode 3.  */
	*pREG_PORTD_DIR_SET = BITM_PORT_DATA_PX11;
}

//#define USE_SOFT_SWITCHES

#include "common/dpia.c"
